/*
** net_api.h
**
** Made by mycroft (mycroft)
** <mycroft@minithins.net> on virgaria.minithins.net
**
** Started on  Wed Jan  1 16:23:30 2003 mycroft
** Last update Wed Jan  1 17:05:33 2003 mycroft
*/

#ifndef _NET_API_
#define _NET_API_

#define NOMBRE_MEMOIRE 4

/* definition des types */ 

typedef unsigned char TAddress;
  /* Adresse */
typedef unsigned char TType;
  /* Type de trame */ 

typedef struct tampon_t
{
  unsigned char taille;
  unsigned char *ptr_data;
} Tampon;

typedef struct ttrame_t 
{
  TAddress AS; /* adresse source */
  TAddress AD; /* adresse desitionation */
#define DATA 0x01
#define ACK  0x02
  TType TYPE;
  unsigned short num;
  unsigned char taille; /* taille des donnees, de 0 a 255 */
  unsigned char *ptr_data; /* pointeur vers les donnees */
  unsigned char crc;
} TTrame;

#define FILE_NET_SRC "/tmp/couche_reseau_source"
#define FILE_PHY "/tmp/couche_physique"
#define FILE_NET_DST "/tmp/couche_reseau_destination"

/* Misc function for files creation and so on ... */

int net_init (void);
int net_close (void);
int net_ok (void);

/* Fonctions relatives aux signaux */

/* Il y a des donnees dans FILE_NET a recup. par l'envoyeur */ 
#define SigEmis 0x01

/* Il y a des donnees dans FILE_PHY a recup. par le recepteur */
#define SigRecPhy 0x02

/* FILE_NET a recu des donnees, mais elle a fini de les traiter */
#define SigRec 0x04

/* Temporisation */
#define SigTempo 0x08

void Tempo (unsigned int t);

int Attendre (unsigned char signaux);
void Effacer (unsigned char signaux);
int Signale (unsigned char signaux);


int Prendre_de_la_couche_reseau (
        TAddress *AS,
        TAddress *AD,
        Tampon *donnes);

unsigned char calcule_crc (unsigned char len, unsigned char *data);

int Construire_trame (
        TAddress AS,
        TAddress AD,
        Tampon T,
        unsigned short num,
        TTrame *Trame);

int Construire_trame_ACK (
        TAddress AS,
        TAddress AD,
        Tampon T,
        unsigned short num,
        TTrame *Trame);

int Envoyer_vers_couche_physique (TTrame Trame);

int Prendre_de_la_couche_physique (TTrame *Trame);

int Recuperer_donnees (
        TAddress *AS,
        TAddress *AD,
        Tampon *T,
        unsigned short *num,
        TTrame Trame);

int Envoyer_vers_couche_reseau (
        Tampon phear,
        TAddress ASR,
        TAddress ADR);


void vide_trame_tab (unsigned short NotACKTrame[NOMBRE_MEMOIRE]);
int add_trame_tab (
    unsigned short NotACKTrame[NOMBRE_MEMOIRE],
    unsigned short num);
void rem_trame_tab (
    unsigned short NotACKTrame[NOMBRE_MEMOIRE],
    unsigned short num);
int yatildelaplace_trame_tab (unsigned short NotACKTrame[NOMBRE_MEMOIRE]);
void copie_trame (TTrame *src, TTrame *dst);



#endif
